/* tde95r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

int main(void)
{
    /* Builtin functions */
    double exp(double), cos(double), sin(double);

    /* Local variables */
    extern int de95r_c(U_fp, U_fp, U_fp, int *, float *, float *, float *,
                       float *, float *, float *, float *, float *, float *,
                       int *);
    static float hmin;
    static int ierr;
    extern int f_c();
    static float h__;
    static int m;
    static float p, r__[93], y[4], y1, y2, y3, y4;
    extern int fj_c();
    static int ih;
    extern int fx_c();
    static float xk, xn, yn[4], eps;

    m = 4;
    xn = 0.f;
    yn[0] = 10.f;
    yn[1] = 11.f;
    yn[2] = 111.f;
    yn[3] = 111.f;
    hmin = 1e-10f;
    eps = .01f;
    p = 1e3f;
    xk = 10.f;
/*  BCEHE TOHOO PEEH CCTEM: */
    y1 = (float)exp((float)(xk * -100.f)) * 10.f;
    y2 = y1 + (float)exp((float)(-xk)) * ((float)cos(xk) + (float)sin(xk));
    y3 = y2 + (float)exp((float)(xk * -1e4f)) * 100.f *
         (float)cos((float)(xk * 10.f));
    y4 = y3 + (float)exp((float)(xk * -1e4f)) * 100.f *
         (float)sin((float)(xk * 10.f));

    printf("\n %16.7e %16.7e ", y1, y2);
    printf("\n %16.7e %16.7e \n", y3, y4);
    ih = 0;
L10:
    ++ih;
    h__ = .01f;
    de95r_c((U_fp)f_c, (U_fp)fj_c, (U_fp)fx_c, &m, &xn, yn, &xk, &hmin, &eps, &p,
            &h__, y, r__, &ierr);

    printf("\n %7.1e \n", eps);
    printf("\n %16.7e %16.7e ", y[0], y[1]);
    printf("\n %16.7e %16.7e \n", y[2], y[3]);
    printf("\n %16.7e \n", h__);
    eps *= .01f;
    if (ih < 3) {
        goto L10;
    }
    return 0;
} /* main */

int f_c(float *x, float *y, float *dy, int *m)
{
    /* Builtin functions */
    double exp(double), cos(double);

    /* Local variables */
    static float t1;

    /* Parameter adjustments */
    --dy;
    --y;

    /* Function Body */
    dy[1] = y[1] * -100.f;
    t1 = (float)exp((float)(*x * -100.f)) * 20.f +
         (float)exp((float)(-(*x))) * 2.f * (float)cos(*x);
    dy[2] = dy[1] - y[2] * 2.f + t1;
    dy[3] = dy[1] + y[2] * 9998.f - y[3] * 9990.f - y[4] * 10.f + t1;
    dy[4] = dy[1] + y[2] * 9988.f + y[3] * 20.f - y[4] * 10010.f + t1;
    return 0;
} /* f_c */

int fj_c(float *x, float *y, float *df, int *m)
{
#define df_ref(a_1,a_2) df[(a_2)*4 + a_1]

    /* Parameter adjustments */
    df -= 5;
    --y;

    /* Function Body */
    df_ref(1, 1) = -100.f;
    df_ref(1, 2) = 0.f;
    df_ref(1, 3) = 0.f;
    df_ref(1, 4) = 0.f;
    df_ref(2, 1) = -100.f;
    df_ref(2, 2) = -2.f;
    df_ref(2, 3) = 0.f;
    df_ref(2, 4) = 0.f;
    df_ref(3, 1) = -100.f;
    df_ref(3, 2) = 9998.f;
    df_ref(3, 3) = -9990.f;
    df_ref(3, 4) = -10.f;
    df_ref(4, 1) = -100.f;
    df_ref(4, 2) = 9988.f;
    df_ref(4, 3) = 20.f;
    df_ref(4, 4) = -10010.f;
    return 0;
} /* fj_c */

#undef df_ref

int fx_c(float *x, float *y, float *dx, int *m)
{
    /* Builtin functions */
    double exp(double), cos(double), sin(double);

    /* Parameter adjustments */
    --dx;
    --y;

    /* Function Body */
    dx[1] = 0.f;
    dx[2] = (float)exp((float)(*x * -100.f)) * -2e3f -
            (float)exp((float)(-(*x))) * 2.f * ((float)cos(*x) +
            (float)sin(*x));
    dx[3] = dx[2];
    dx[4] = dx[2];
    return 0;
} /* fx_c */
